"use strict";

var _require = require("./hit"),
    hit = _require.hit;

var _require2 = require("./guid"),
    guid = _require2.guid;

var _require3 = require("./now"),
    now = _require3.now;

test("hit()", function () {
  var actual = hit(guid(), now());
  var expected = {
    type: "hit",
    cmds: [guid(), now()]
  };
  expect(actual).toEqual(expected);
});

test("hit() should throw if no commands", function () {
  expect(function () {
    return hit();
  }).toThrow("At least one cmd is required.");
});

test("hit() should throw if invalid cmds", function () {
  expect(function () {
    return hit({});
  }).toThrow("All cmds must have a type.");
});
//# sourceMappingURL=hit.spec.js.map