"use strict";

function delay(fn, time) {
  return new Promise(function (resolve, reject) {
    try {
      setTimeout(function () {
        resolve(fn());
      }, time);
    } catch (e) {
      reject(e);
    }
  });
}

function retry(_ref, _ref2) {
  var cmd = _ref.cmd,
      durations = _ref.durations,
      defaultValue = _ref.defaultValue;
  var call = _ref2.call,
      context = _ref2.context,
      interpreters = _ref2.interpreters,
      _ref2$index = _ref2.index,
      index = _ref2$index === undefined ? 0 : _ref2$index;

  return call(context, interpreters, regeneratorRuntime.mark(function _callee() {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return cmd;

          case 3:
            return _context.abrupt("return", _context.sent);

          case 6:
            _context.prev = 6;
            _context.t0 = _context["catch"](0);

            if (!(index >= durations.length)) {
              _context.next = 14;
              break;
            }

            if (!(defaultValue === undefined)) {
              _context.next = 13;
              break;
            }

            throw _context.t0;

          case 13:
            return _context.abrupt("return", defaultValue);

          case 14:
            return _context.abrupt("return", delay(function () {
              return retry({ cmd: cmd, durations: durations, defaultValue: defaultValue }, { call: call, context: context, interpreters: interpreters, index: index + 1 });
            }, durations[index]));

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 6]]);
  }));
}

module.exports = {
  retry: retry
};
//# sourceMappingURL=retry.js.map